]> Git Repo - J-u-boot.git/blame - MAKEALL
Timer: Remove reset_timer_masked()
[J-u-boot.git] / MAKEALL
CommitLineData
f2352877 1#!/bin/bash
7ebf7443 2
0777eafb
WD
3# Tool mainly for U-Boot Quality Assurance: build one or more board
4# configurations with minimal verbosity, showing only warnings and
5# errors.
6#
7# There are several ways to select which boards to build.
8#
9# Traditionally, architecture names (like "powerpc"), CPU family names
10# (like "mpc83xx") or board names can be specified on the command
11# line; without any arguments, MAKEALL defaults to building all Power
12# Architecture systems (i. e. same as for "MAKEALL powerpc").
13#
cd57b0bb 14# With the introduction of the board.cfg file, it has become possible
0777eafb
WD
15# to provide additional selections. We use standard command line
16# options for this:
17#
18# -a or --arch : Select architecture
19# -c or --cpu : Select CPU family
20# -s or --soc : Select SoC type
21# -v or --vendor: Select board vendor
22#
23# Selections by these options are logically ANDed; if the same option
24# is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
25# will select all configurations where the vendor is either FOO or
26# BAR. Any additional arguments specified on the command line are
27# always build additionally.
28#
29# Examples:
30#
31# - build all Power Architecture boards:
32#
33# MAKEALL -a powerpc
34# or
35# MAKEALL --arch powerpc
36# or
37# MAKEALL powerpc
38#
39# - build all PowerPC boards manufactured by vendor "esd":
40#
41# MAKEALL -a powerpc -v esd
42#
43# - build all PowerPC boards manufactured either by "keymile" or
44# "siemens":
45#
46# MAKEALL -a powerpc -v keymile -v siemens
47#
48# - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
49#
50# MAKEALL -c mpc83xx -v freescale 4xx
51#
52#########################################################################
53
54SHORT_OPTS="a:c:v:s:"
55LONG_OPTS="arch:,cpu:,vendor:,soc:"
56
57# Option processing based on util-linux-2.13/getopt-parse.bash
58
071bc923 59# Note that we use `"$@"' to let each command-line parameter expand to a
0777eafb
WD
60# separate word. The quotes around `$@' are essential!
61# We need TEMP as the `eval set --' would nuke the return value of
62# getopt.
63TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
64 -n 'MAKEALL' -- "$@"`
65
66if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
67
68# Note the quotes around `$TEMP': they are essential!
69eval set -- "$TEMP"
70
71SELECTED=''
72
73while true ; do
74 case "$1" in
75 -a|--arch)
76 # echo "Option ARCH: argument \`$2'"
77 if [ "$opt_a" ] ; then
78 opt_a="${opt_a%)} || \$2 == \"$2\")"
79 else
80 opt_a="(\$2 == \"$2\")"
81 fi
82 SELECTED='y'
83 shift 2 ;;
84 -c|--cpu)
85 # echo "Option CPU: argument \`$2'"
86 if [ "$opt_c" ] ; then
87 opt_c="${opt_c%)} || \$3 == \"$2\")"
88 else
89 opt_c="(\$3 == \"$2\")"
90 fi
91 SELECTED='y'
92 shift 2 ;;
93 -s|--soc)
94 # echo "Option SoC: argument \`$2'"
95 if [ "$opt_s" ] ; then
96 opt_s="${opt_s%)} || \$6 == \"$2\")"
97 else
98 opt_s="(\$6 == \"$2\")"
99 fi
100 SELECTED='y'
101 shift 2 ;;
102 -v|--vendor)
103 # echo "Option VENDOR: argument \`$2'"
104 if [ "$opt_v" ] ; then
105 opt_v="${opt_v%)} || \$5 == \"$2\")"
106 else
107 opt_v="(\$5 == \"$2\")"
108 fi
109 SELECTED='y'
110 shift 2 ;;
111 --)
112 shift ; break ;;
113 *)
114 echo "Internal error!" >&2 ; exit 1 ;;
115 esac
116done
117# echo "Remaining arguments:"
118# for arg do echo '--> '"\`$arg'" ; done
119
120FILTER="\$1 !~ /^#/"
121[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
122[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
123[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
124[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
125
126if [ "$SELECTED" ] ; then
127 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
cd57b0bb
PT
128
129 # Make sure some boards from boards.cfg are actually found
130 if [ -z "$SELECTED" ] ; then
131 echo "Error: No boards selected, invalid arguments"
132 exit 1
133 fi
0777eafb
WD
134fi
135
136#########################################################################
137
40a28f08
PT
138# Print statistics when we exit
139trap exit 1 2 3 15
140trap print_stats 0
141
7fa6a2f3
WD
142# Determine number of CPU cores if no default was set
143: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
144
145if [ "$BUILD_NCPUS" -gt 1 ]
146then
55f786d8 147 JOBS="-j $((BUILD_NCPUS + 1))"
7fa6a2f3
WD
148else
149 JOBS=""
150fi
151
a8c7c708 152
7ebf7443
WD
153if [ "${CROSS_COMPILE}" ] ; then
154 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
155else
156 MAKE=make
157fi
158
f9328639
MB
159if [ "${MAKEALL_LOGDIR}" ] ; then
160 LOG_DIR=${MAKEALL_LOGDIR}
161else
162 LOG_DIR="LOG"
163fi
887e2ec9 164
f9328639
MB
165if [ ! "${BUILD_DIR}" ] ; then
166 BUILD_DIR="."
167fi
168
4f0645eb 169[ -d ${LOG_DIR} ] || mkdir ${LOG_DIR} || exit 1
7ebf7443
WD
170
171LIST=""
172
40a28f08
PT
173# Keep track of the number of builds and errors
174ERR_CNT=0
175ERR_LIST=""
176TOTAL_CNT=0
f2352877 177RC=0
40a28f08 178
9ec49f8f
MF
179# Helper funcs for parsing boards.cfg
180boards_by_field()
181{
182 awk \
183 -v field="$1" \
184 -v select="$2" \
185 '($1 !~ /^#/ && $field == select) { print $1 }' \
186 boards.cfg
187}
188boards_by_arch() { boards_by_field 2 "$@" ; }
189boards_by_cpu() { boards_by_field 3 "$@" ; }
0a41edaa 190boards_by_soc() { boards_by_field 6 "$@" ; }
9ec49f8f 191
0db5bca8
WD
192#########################################################################
193## MPC5xx Systems
194#########################################################################
195
9ec49f8f 196LIST_5xx="$(boards_by_cpu mpc5xx)"
0db5bca8 197
945af8d7
WD
198#########################################################################
199## MPC5xxx Systems
200#########################################################################
201
2ae18241 202LIST_5xxx="$(boards_by_cpu mpc5xxx)"
945af8d7 203
8993e54b
RJ
204#########################################################################
205## MPC512x Systems
206#########################################################################
207
2ae18241 208LIST_512x="$(boards_by_cpu mpc512x)"
945af8d7 209
7ebf7443
WD
210#########################################################################
211## MPC8xx Systems
212#########################################################################
9ec49f8f 213
2ae18241 214LIST_8xx="$(boards_by_cpu mpc8xx)"
7ebf7443
WD
215
216#########################################################################
217## PPC4xx Systems
218#########################################################################
219
2ae18241 220LIST_4xx="$(boards_by_cpu ppc4xx)"
7ebf7443 221
983fda83
WD
222#########################################################################
223## MPC8220 Systems
224#########################################################################
225
9ec49f8f 226LIST_8220="$(boards_by_cpu mpc8220)"
983fda83 227
7ebf7443
WD
228#########################################################################
229## MPC824x Systems
230#########################################################################
231
2ae18241 232LIST_824x="$(boards_by_cpu mpc824x)"
592c5cab 233
7ebf7443 234#########################################################################
7aa78614 235## MPC8260 Systems (includes 8250, 8255 etc.)
7ebf7443
WD
236#########################################################################
237
2ae18241 238LIST_8260="$(boards_by_cpu mpc8260)"
7ebf7443 239
f046ccd1
EL
240#########################################################################
241## MPC83xx Systems (includes 8349, etc.)
242#########################################################################
243
2ae18241 244LIST_83xx="$(boards_by_cpu mpc83xx)"
f046ccd1 245
42d1f039
WD
246#########################################################################
247## MPC85xx Systems (includes 8540, 8560 etc.)
248#########################################################################
249
2ae18241 250LIST_85xx="$(boards_by_cpu mpc85xx)"
42d1f039 251
822d5536
JL
252#########################################################################
253## MPC86xx Systems
254#########################################################################
255
2ae18241 256LIST_86xx="$(boards_by_cpu mpc86xx)"
822d5536 257
7ebf7443
WD
258#########################################################################
259## 74xx/7xx Systems
260#########################################################################
261
2ae18241 262LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
7ebf7443 263
d9a42c0a
WD
264#########################################################################
265## PowerPC groups
266#########################################################################
267
268LIST_TSEC=" \
269 ${LIST_83xx} \
270 ${LIST_85xx} \
271 ${LIST_86xx} \
272"
273
a47a12be 274LIST_powerpc=" \
fb56579f 275 ${LIST_5xx} \
3deca9d4 276 ${LIST_512x} \
fb56579f
KP
277 ${LIST_5xxx} \
278 ${LIST_8xx} \
279 ${LIST_8220} \
280 ${LIST_824x} \
281 ${LIST_8260} \
282 ${LIST_83xx} \
283 ${LIST_85xx} \
284 ${LIST_86xx} \
285 ${LIST_4xx} \
2ae18241 286 ${LIST_74xx_7xx}\
fb56579f 287"
7ebf7443 288
a47a12be
SR
289# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
290# still using "ppc" instead of "powerpc"
291LIST_ppc=" \
292 ${LIST_powerpc} \
293"
294
7ebf7443
WD
295#########################################################################
296## StrongARM Systems
297#########################################################################
298
9ec49f8f 299LIST_SA="$(boards_by_cpu sa1100)"
7ebf7443
WD
300
301#########################################################################
302## ARM7 Systems
303#########################################################################
304
fb56579f
KP
305LIST_ARM7=" \
306 ap7 \
307 ap720t \
308 armadillo \
309 B2 \
310 ep7312 \
311 evb4510 \
312 impa7 \
313 integratorap \
314 lpc2292sodimm \
315 modnet50 \
316 SMN42 \
74f4304e 317"
7ebf7443
WD
318
319#########################################################################
320## ARM9 Systems
321#########################################################################
322
fb56579f 323LIST_ARM9=" \
43a5f0df 324 a320evb \
fb56579f
KP
325 ap920t \
326 ap922_XA10 \
327 ap926ejs \
328 ap946es \
329 ap966 \
c291e2fc 330 aspenite \
fb56579f
KP
331 cp920t \
332 cp922_XA10 \
333 cp926ejs \
334 cp946es \
335 cp966 \
2819e136 336 da830evm \
89b765c7 337 da850evm \
cf3c142e
MK
338 edb9301 \
339 edb9302 \
340 edb9302a \
341 edb9307 \
342 edb9307a \
343 edb9312 \
344 edb9315 \
345 edb9315a \
ce9c227c 346 edminiv2 \
16b76705 347 guruplug \
10bc241d 348 imx27lite \
18a056a1 349 jadecpu \
83b40c31 350 km_kirkwood \
fb56579f 351 lpd7a400 \
bbe31092 352 magnesium \
4abc5bff 353 mv88f6281gtw_ge \
fb56579f
KP
354 mx1ads \
355 mx1fs2 \
356 netstar \
ceb70b46
JCPV
357 nhk8815 \
358 nhk8815_onenand \
fb56579f
KP
359 omap1510inn \
360 omap1610h2 \
361 omap1610inn \
a3543d6d 362 omap5912osk \
fb56579f 363 omap730p2 \
e92daeb5 364 openrd_base \
21861f2d
CA
365 openrd_client \
366 openrd_ultimate \
01fa4e8c 367 portl2 \
fbc8365a 368 rd6281a \
fb56579f
KP
369 sbc2410x \
370 scb9328 \
55dd4ba5 371 sheevaplug \
fb56579f
KP
372 smdk2400 \
373 smdk2410 \
7e074158 374 spear300 \
080cfee7 375 spear310 \
7da69236 376 spear320 \
566c9c16 377 spear600 \
fb56579f
KP
378 VCMA9 \
379 versatile \
380 versatileab \
381 versatilepb \
382 voiceblue \
383 davinci_dvevm \
384 davinci_schmoogie \
c7f879ec 385 davinci_sffsdr \
fb56579f 386 davinci_sonata \
28b00324 387 davinci_dm355evm \
5df65cf5 388 davinci_dm355leopard \
3fca2929 389 davinci_dm365evm \
6ab176d7 390 davinci_dm6467evm \
6f21347d 391"
7ebf7443 392
74f4304e
WD
393#########################################################################
394## ARM10 Systems
395#########################################################################
fb56579f
KP
396LIST_ARM10=" \
397 integratorcp \
398 cp1026 \
74f4304e
WD
399"
400
8ed96046
WD
401#########################################################################
402## ARM11 Systems
403#########################################################################
0c692673
GL
404LIST_ARM11=" \
405 cp1136 \
406 omap2420h4 \
407 apollon \
408 imx31_litekit \
409 imx31_phycore \
410 imx31_phycore_eet \
411 mx31ads \
8449f287 412 mx31pdk \
d08e5ca3 413 mx31pdk_nand \
0c692673
GL
414 qong \
415 smdk6400 \
5cc48f7e 416 tnetv107x_evm \
74f4304e 417"
8ed96046 418
f904cdbb 419#########################################################################
f56348af 420## ARMV7 Systems
f904cdbb 421#########################################################################
f56348af 422LIST_ARMV7=" \
915162da 423 am3517_crane \
ed01e45c 424 am3517_evm \
b80e41ac 425 ca9x4_ct_vxp \
c35d7cf0 426 devkit8000 \
fb6e1f1b 427 dig297 \
8a3f6bb6 428 igep0020 \
1a832dc4 429 igep0030 \
c5fb70c9 430 mx51evk \
f904cdbb 431 omap3_beagle \
9d0fc811 432 omap3_overo \
ad9bc8e5 433 omap3_evm \
2be2c6cc 434 omap3_pandora \
e63e5904 435 omap3_sdp3430 \
7379f45a 436 omap3_zoom1 \
376aee78 437 omap3_zoom2 \
c57cca25 438 omap4_panda \
3e76d62a 439 omap4_sdp4430 \
c474a8eb 440 s5p_goni \
8bc4ee9e 441 smdkc100 \
f904cdbb
DB
442"
443
602cac13
JCPV
444#########################################################################
445## AT91 Systems
446#########################################################################
447
0a41edaa
AB
448LIST_at91="$(boards_by_soc at91)\
449 $(boards_by_soc at91rm9200)\
22ee6473
SG
450 at91sam9260ek \
451 at91sam9261ek \
452 at91sam9263ek \
d8380c9d 453 at91sam9g10ek \
22ee6473 454 at91sam9g20ek \
5ccc2d99 455 at91sam9m10g45ek \
22ee6473 456 at91sam9rlek \
b5d289fc 457 pm9g45 \
2dc851e3
AT
458 SBC35_A9G20 \
459 TNY_A9260 \
460 TNY_A9G20 \
602cac13
JCPV
461"
462
7ebf7443
WD
463#########################################################################
464## Xscale Systems
465#########################################################################
466
7c957c0e 467LIST_pxa="$(boards_by_cpu pxa)"
7ebf7443 468
9ec49f8f 469LIST_ixp="$(boards_by_cpu ixp)
fb56579f
KP
470 pdnb3 \
471 scpu \
472"
7ebf7443 473
d9a42c0a
WD
474#########################################################################
475## ARM groups
476#########################################################################
2d5b561e 477
f904cdbb
DB
478LIST_arm=" \
479 ${LIST_SA} \
480 ${LIST_ARM7} \
481 ${LIST_ARM9} \
482 ${LIST_ARM10} \
483 ${LIST_ARM11} \
f56348af 484 ${LIST_ARMV7} \
f904cdbb
DB
485 ${LIST_at91} \
486 ${LIST_pxa} \
487 ${LIST_ixp} \
8ed96046 488"
7ebf7443 489
c021880a 490#########################################################################
b62bdffb 491## MIPS Systems (default = big endian)
c021880a
WD
492#########################################################################
493
fb56579f
KP
494LIST_mips4kc=" \
495 incaip \
0764c164 496 qemu_mips \
2a61eff6
SR
497 vct_platinum \
498 vct_platinum_small \
499 vct_platinum_onenand \
500 vct_platinum_onenand_small \
501 vct_platinumavc \
502 vct_platinumavc_small \
503 vct_platinumavc_onenand \
504 vct_platinumavc_onenand_small \
505 vct_premium \
506 vct_premium_small \
507 vct_premium_onenand \
508 vct_premium_onenand_small \
fb56579f 509"
c021880a 510
b38a5699 511LIST_mips5kc=""
3e38691e 512
fb56579f
KP
513LIST_au1xx0=" \
514 dbau1000 \
515 dbau1100 \
516 dbau1500 \
517 dbau1550 \
518 dbau1550_el \
519 gth2 \
520"
5da627a4 521
fb56579f
KP
522LIST_mips=" \
523 ${LIST_mips4kc} \
524 ${LIST_mips5kc} \
525 ${LIST_au1xx0} \
526"
c021880a 527
b62bdffb
WD
528#########################################################################
529## MIPS Systems (little endian)
530#########################################################################
531
532LIST_mips4kc_el=""
533
534LIST_mips5kc_el=""
535
fb56579f
KP
536LIST_au1xx0_el=" \
537 dbau1550_el \
b09258c5 538 pb1000 \
fb56579f 539"
b62bdffb 540
fb56579f
KP
541LIST_mips_el=" \
542 ${LIST_mips4kc_el} \
543 ${LIST_mips5kc_el} \
544 ${LIST_au1xx0_el} \
545"
b62bdffb 546
7a8e9bed 547#########################################################################
fea25720 548## x86 Systems
7a8e9bed
WD
549#########################################################################
550
fea25720 551LIST_x86="$(boards_by_arch x86)"
7a8e9bed 552
5c952cf0
WD
553#########################################################################
554## Nios-II Systems
555#########################################################################
556
4827d067 557LIST_nios2="$(boards_by_arch nios2)"
5c952cf0 558
857cad37
WD
559#########################################################################
560## MicroBlaze Systems
561#########################################################################
562
9ec49f8f 563LIST_microblaze="$(boards_by_arch microblaze)"
857cad37 564
f8c3b4f3
ZL
565#########################################################################
566## ColdFire Systems
567#########################################################################
568
9ec49f8f 569LIST_coldfire="$(boards_by_arch m68k)
9d79e575 570 astro_mcf5373l \
fb56579f
KP
571 cobra5272 \
572 EB+MCF-EV123 \
573 EB+MCF-EV123_internal \
1552af70 574 M52277EVB \
4a442d31 575 M5235EVB \
aa5f1f9d
TL
576 M5329AFEE \
577 M5373EVB \
05316f8e 578 M54451EVB \
8ae158cd 579 M54455EVB \
57a12720
TL
580 M5475AFE \
581 M5485AFE \
9acb626f 582"
f8c3b4f3 583
6ccec449
WD
584#########################################################################
585## AVR32 Systems
586#########################################################################
587
9ec49f8f 588LIST_avr32="$(boards_by_arch avr32)"
6ccec449 589
ef26a08f
AL
590#########################################################################
591## Blackfin Systems
592#########################################################################
593
36cf8cb4 594LIST_blackfin="$(boards_by_arch blackfin)"
ef26a08f 595
c7144373
JCPV
596#########################################################################
597## SH Systems
598#########################################################################
599
e0f0e527 600LIST_sh2="$(boards_by_cpu sh2)"
3771c69d 601LIST_sh3="$(boards_by_cpu sh3)"
03626be3 602LIST_sh4="$(boards_by_cpu sh4)"
d9a42c0a 603
03626be3 604LIST_sh="$(boards_by_arch sh)"
c7144373 605
c2f02da2
DH
606#########################################################################
607## SPARC Systems
608#########################################################################
609
9ec49f8f 610LIST_sparc="$(boards_by_arch sparc)"
7ebf7443
WD
611
612#-----------------------------------------------------------------------
613
614build_target() {
615 target=$1
616
617 ${MAKE} distclean >/dev/null
d70d8ccc 618 ${MAKE} -s ${target}_config
f9328639
MB
619
620 ${MAKE} ${JOBS} all 2>&1 >${LOG_DIR}/$target.MAKELOG \
621 | tee ${LOG_DIR}/$target.ERR
f2352877
PT
622
623 # Check for 'make' errors
624 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
625 RC=1
626 fi
627
40a28f08
PT
628 if [ -s ${LOG_DIR}/$target.ERR ] ; then
629 ERR_CNT=$((ERR_CNT + 1))
630 ERR_LIST="${ERR_LIST} $target"
631 else
632 rm ${LOG_DIR}/$target.ERR
633 fi
634
635 TOTAL_CNT=$((TOTAL_CNT + 1))
f9328639 636
208447f8 637 ${CROSS_COMPILE}size ${BUILD_DIR}/u-boot \
f9328639 638 | tee -a ${LOG_DIR}/$target.MAKELOG
7ebf7443 639}
9ec49f8f
MF
640build_targets() {
641 for t in "$@" ; do
642 # If a LIST_xxx var exists, use it. But avoid variable
643 # expansion in the eval when a board name contains certain
644 # characters that the shell interprets.
645 case ${t} in
646 *[-+=]*) list= ;;
647 *) list=$(eval echo '${LIST_'$t'}') ;;
648 esac
649 if [ -n "${list}" ] ; then
650 build_targets ${list}
651 else
652 build_target ${t}
653 fi
654 done
655}
7ebf7443
WD
656
657#-----------------------------------------------------------------------
658
40a28f08
PT
659print_stats() {
660 echo ""
661 echo "--------------------- SUMMARY ----------------------------"
662 echo "Boards compiled: ${TOTAL_CNT}"
663 if [ ${ERR_CNT} -gt 0 ] ; then
664 echo "Boards with warnings or errors: ${ERR_CNT} (${ERR_LIST} )"
665 fi
666 echo "----------------------------------------------------------"
f2352877
PT
667
668 exit $RC
40a28f08 669}
7ebf7443 670
40a28f08 671#-----------------------------------------------------------------------
9ec49f8f 672
0777eafb
WD
673# Build target groups selected by options, plus any command line args
674set -- ${SELECTED} "$@"
675# run PowerPC by default
9ec49f8f 676[ $# = 0 ] && set -- powerpc
9ec49f8f 677build_targets "$@"
This page took 0.316834 seconds and 4 git commands to generate.